function loaddata(city,data,mapId){
    data =data.replace(/\n/g,"<br/>");
    data =data.replace(/\r/g,"");
    data=eval('('+data+')');
    
    if(map==null)
    {
        map = new BMap.Map("allmap");
        map.enableScrollWheelZoom(true);
        map.addControl(new BMap.NavigationControl());
        
        
        loaction();
        map.addEventListener("zoomend", function()
        {
             //console.log("地图放大级别：" +map.getZoom() + "级");
             var maplevel = map.getZoom();
             if(maplevel>=13)
             {
             $(".nametip").show();
             }
             else
             {
             $(".nametip").hide();
             }
             
        });
    }
    
    //map.addControl(new BMap.ScaleControl());
    //map.addControl(new BMap.OverviewMapControl());
    nationpoints = data.nationpoints;
    data = data.rows;
    
    map.clearOverlays();
    var nationpoint;
    /*国控点*/
    for(i=0;i<nationpoints.length;i++)
    {
        var content ="<div id='np" + i + "' style='width:100%;height:300px;'></div>";
        showIconMarker(i,nationpoints);
        
        if(mapId!=null && mapId>=0 && nationpoints[i]['pointname'] == data[mapId]['neighborpoint'])
        {
            var lat = nationpoints[i]['latitude'];
            var lng = nationpoints[i]['longitude'];
            nationpoint = new BMap.Point(lng,lat);
        }
    }
    
    if(mapId==null || mapId<0)
    {
        map.centerAndZoom(city,12);
        for(i=0;i<data.length;i++)
        {
            showMarker(i,data,false,null);
        }
    }
    else
    {
        showMarker(mapId,data,true,nationpoint);
    }
}



function showIconMarker(i,data)
{
    var lat = data[i]['latitude'];
    var lng = data[i]['longitude'];
    var point = new BMap.Point(lng,lat);
    var imgUrl = "img/icon/6.png";
    var myIcon = new BMap.Icon(imgUrl, new BMap.Size(22,31), {
                               offset: new BMap.Size(0,0),
                               });
    var opts = {
        position : point,
        offset : new BMap.Size(0, -15),
    icon: myIcon
        
    };
    var pointmarker = new BMap.Marker(point,opts);
    map.addOverlay(pointmarker);
    maplevel = map.getZoom();
    var nametip = data[i].pointname;
    if (maplevel > 0) {
        
        var len = nametip.length;
        var label_tip; // 创建文本标注对象
        // 国控点
        var opts_tip = {
            position : point, // 指定文本标注所在的地理位置
            offset : new BMap.Size(-len * 8, 1)//设置文本偏移量
        };
        label_tip = new BMap.Label("<div class='nametip'>" + nametip + "</div>", opts_tip);
        label_tip.setStyle({
                           color : "black",
                           background : 'rgba(255,255,255,0)',
                           fontSize : "12px",
                           border : 'none',
                           width : "auto",
                           textAlign : "center",
                           height : "22px",
                           lineHeight : "18px",
                           paddingLeft:"5px",
                           paddingRight:"5px"
                           });
        map.addOverlay(label_tip);
    }
    var content = "<div id='npchart_" + i + "' style='width:100%;height:300px;'></div>"
    var opts = {
        width : 330,     // 信息窗口宽度
        height: 300,     // 信息窗口高度
        title : "" , // 信息窗口标题
        enableMessage:false//设置允许信息窗发送短息
    };
    var infoWindow = new BMap.InfoWindow(content,opts);  // 创建信息窗口对象
    pointmarker.addEventListener("click",function(e){
        map.openInfoWindow(infoWindow,point); //开启信息窗口
        openNationInfo(i,nametip,data[i],e)}
    );
}

function openNationInfo(k,name,data,e){
    
    var sum=0;
    var pointname = data.pointname;
    var wlData = new Array();
    var wdData = new Array();
    wdData.splice(0,wdData.length);
    wlData.splice(0,wlData.length);
    data = data.wd;
    
    for(var i=0;i<data.length;i++){
        var wd = data[i]['wind'];
        var wid = getWindLevelByStr(wd);
        var num = parseInt(data[i]['num']);
        var wl = parseFloat(data[i]['ws_avg']);
        var wl_min = parseFloat(data[i]['ws_min']);
        var wl_max = parseFloat(data[i]['ws_max']);
        
        var aqi = parseInt(data[i]['aqi']);
        var pm2_5 = parseInt(data[i]['pm2_5']);
        var pm10 = parseInt(data[i]['pm10']);
        var so2 = parseInt(data[i]['so2']);
        var no2 = parseInt(data[i]['no2']);
        var co = parseFloat(data[i]['co']);
        var o3 = parseInt(data[i]['o3']);
        
        var index = 0;
        var item = 'PM10';
        switch(item)
        {
            case 'AQI': index = getAQILevelIndex(aqi);break;
            case 'PM2.5': index = getPM25LevelIndex(pm2_5);break;
            case 'PM10': index = getPM10LevelIndex(pm10);break;
            case 'SO2': index = getSO2LevelIndex(so2);break;
            case 'NO2': index = getNO2LevelIndex(no2);break;
            case 'CO': index = getCOLevelIndex(co);break;
            case 'O3': index = getO3LevelIndex(o3);break;
            case '综合指数':index = getComplexIndexLevelIndex(complexindex);break;
        }
        color = getlevelColor(index);
        
        sum = sum + num;
        wdData.push({
                    name:wd,
                    y: num,
                    wid: wid,
                    color: color,
                    pm2_5: pm2_5,
                    pm10: pm10,
                    so2: so2,
                    no2: no2,
                    co: co,
                    o3: o3
                    });
        wlData.push({
                    name:wd,
                    y: wl,
                    wl_min: wl_min,
                    wl_max: wl_max,
                    wid:wid
                    });
    }
    for(i=0;i<wdData.length;i++)
    {
        wdData[i].y = parseFloat((100*wdData[i].y/sum).toFixed(1));
    }
    wdData.sort(createComparionFunASC("wid"));
    wlData.sort(createComparionFunASC("wid"));
    showWDChart('npchart_' + k,pointname,wdData,wlData);
}

/**
 * JS对象数组排序
 */
function createComparionFun(propertyName)
{
    return function(object1,object2)
    {
        var value1=parseFloat(object1[propertyName]);
        var value2=parseFloat(object2[propertyName]);
        return value2-value1;
    }
}

/**
 * JS对象数组排序
 */
function createComparionFunASC(propertyName)
{
    return function(object1,object2)
    {
        
        var value1=parseFloat(object1[propertyName]);
        var value2=parseFloat(object2[propertyName]);
        return value1-value2;
    }
}

function showWDChart(container,pointname,wddata,wldata)
{
    $('#' + container).highcharts({
                                  chart: {
                                  polar: true
                                  },
                                  
                                  title: {
                                  text: pointname + '风玫瑰图'
                                  },
                                  
                                  subtitle: {
                                  text: ''
                                  },
                                  
                                  pane: {
                                  size: '85%'
                                  },
                                  
                                  legend: {
                                  align: 'right',
                                  verticalAlign: 'top',
                                  y: 100,
                                  layout: 'vertical'
                                  },
                                  
                                  xAxis: {
                                  tickmarkPlacement: 'on',
                                  categories: [
                                               '北风',
                                               '东北风',
                                               '东风',
                                               '东南风',
                                               '南风',
                                               '西南风',
                                               '西风',
                                               '西北风'
                                               ]
                                  },
                                  yAxis: [{
                                          endOnTick: false,
                                          showLastLabel: false,
                                          title: {
                                          text: ''
                                          },
                                          labels:{
                                          enabled: false
                                          }
                                          },{
                                          endOnTick: false,
                                          showLastLabel: false,
                                          title: {
                                          text: ''
                                          },
                                          labels:{
                                          enabled: false
                                          }
                                          }],
                                  
                                  tooltip: {
                                  shared: true, //公用一个提示框
                                  useHTML:true,
                                  formatter: function() {
//                                  return this.x +"<br><table class='table table-hover table-striped table-bordered'>"
//                                  + "<tr><td >频率：</td><td align='' colspan='3'>" + this.points[0].y +" %</td></tr>"
//                                  + "<tr><td>风速：</td><td align='' colspan='3'>" + this.points[1].y.toFixed(1) +" m/s (" + this.points[1].point.wl_min + "~" +   this.points[1].point.wl_max + "m/s)</td></tr>"
//                                  + "<tr><td>PM2.5：</td><td align='right'>" + this.points[0].point.pm2_5 +" ug/m³</td>"
//                                  + "<td>PM10：</td><td align='right'>" + this.points[0].point.pm10 +" ug/m³</td></tr>"
//                                  + "<tr><td>SO2：</td><td align='right'>" + this.points[0].point.so2 +" ug/m³</td>"
//                                  + "<td>NO2：</td><td align='right'>" + this.points[0].point.no2 +" ug/m³</td></tr>"
//                                  + "<tr><td>CO：</td><td align='right'>" + this.points[0].point.co.toFixed(3) +" mg/m³</td>"
//                                  + "<td>O3：</td><td align='right'>" + this.points[0].point.o3 +" ug/m³</td></tr>"
//                                  + "</table>";
                                    return this.x +"<br>频率：" + this.points[0].y + "%<br/>风速：" + this.points[1].y.toFixed(1) +" m/s (" + this.points[1].point.wl_min + "~" +   this.points[1].point.wl_max + "m/s)";
                                  }
                                  },
                                  
                                  plotOptions: {
                                  series: {
                                  stacking: 'normal',
                                  shadow: false,
                                  groupPadding: 0,
                                  pointPlacement: 'on'
                                  }
                                  },
                                  legend: {
                                  enabled: true
                                  },
                                  credits: {
                                  enabled:false
                                  },
                                  series: [{
                                           name: '频率',
                                           type:'column',
                                           data: wddata,
                                           yAxis: 0
                                           },
                                           {
                                           name: '风级',
                                           data: wldata,
                                           color: '#FF8C00',
                                           yAxis: 1
                                           }]
                                  });
}

function showMarker(i,data,locationflag,nationpoint)
{
    var lat = data[i]['latitude'];
    var lng = data[i]['longitude'];

    var point = new BMap.Point(lng,lat);
    if(locationflag)
    {
        map.centerAndZoom(point,15);
        
        var polyline = new BMap.Polyline([
          nationpoint,
          point
          ], {strokeColor:"blue", strokeWeight:3, strokeOpacity:0.5});   //创建折线
        map.addOverlay(polyline);   //增加折线
        
        var tippoint = new BMap.Point((nationpoint.lng+point.lng)/2,(nationpoint.lat+point.lat)/2);
        
        var label_tip; // 创建文本标注对象
        // 国控点
        var opts_tip = {
            position : tippoint, // 指定文本标注所在的地理位置
            offset : new BMap.Size(-20, -15)//设置文本偏移量
        };
        label_tip = new BMap.Label("<div class='nametip'>" + data[i].distance + "m</div>", opts_tip);
        label_tip.setStyle({
                           color : "black",
                           background : 'rgba(255,255,255,0)',
                           fontSize : "12px",
                           border : 'none',
                           width : "auto",
                           textAlign : "center",
                           height : "22px",
                           lineHeight : "18px",
                           paddingLeft:"5px",
                           paddingRight:"5px"
                           });
        map.addOverlay(label_tip);
        
    }
    var content = "";
    thumbnails = data[i].thumbnail.split("|");
    for(j=0;j<data[i].imgnum && j<3;j++)
    {
        content = content +  "<img src='" + thumbnails[j] + "' width='30%' height='60px' /> ";
    }
    var content = content + "<br/><b>污染描述：</b>" + data[i].content +
    "<br/><b>污染类型：</b>" + data[i].pollutanttype +
    "<br/><b>所属区域：</b>" + data[i].region+
    "<br/><b>附近站点：</b>" + data[i].neighborpoint+ "(" + (data[i].distance/1000).toFixed(2) +  "km) " + data[i].direction +
    "<br/><b>取证时间：</b>" + data[i].time
    addMarker(point,content);
}

function loaction()
{
    // 添加定位控件
    var geolocationControl = new BMap.GeolocationControl();
    geolocationControl.addEventListener("locationSuccess", function(e){
                                        // 定位成功事件
                                        var address = '';
                                        address += e.addressComponent.province;
                                        address += e.addressComponent.city;
                                        address += e.addressComponent.district;
                                        address += e.addressComponent.street;
                                        address += e.addressComponent.streetNumber;
                                        //alert("当前定位地址为：" + address);
                                        });
    geolocationControl.addEventListener("locationError",function(e){
                                        // 定位失败事件
                                        alert(e.message);
                                        });
    map.addControl(geolocationControl);
}

function addMarker(point,content){
    var marker = new BMap.Marker(point);
    map.addOverlay(marker);
    addClickHandler(content,marker);
}

function addClickHandler(content,marker){
    marker.addEventListener("click",function(e){
                            openInfo(content,e)}
                            );
}

function openInfo(content,e){
    var opts = {
        width : 260,     // 信息窗口宽度
    height: 220,     // 信息窗口高度
        title : "<b>监督详情</b>" , // 信息窗口标题
    enableMessage:false//设置允许信息窗发送短息
    };
    var p = e.target;
    var point = new BMap.Point(p.getPosition().lng, p.getPosition().lat);
    var infoWindow = new BMap.InfoWindow(content,opts);  // 创建信息窗口对象 
    map.openInfoWindow(infoWindow,point); //开启信息窗口
}